Package org.apache.tools.ant.filters

## Class LineContainsRegExp

- java.lang.Object
- - java.io.Reader
  - - java.io.FilterReader
    - - org.apache.tools.ant.filters.BaseFilterReader
      - - org.apache.tools.ant.filters.BaseParamFilterReader
        - - org.apache.tools.ant.filters.LineContainsRegExp

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `java.lang.Readable`, `ChainableReader`, `Parameterizable`

      public final class LineContainsRegExp
      extends BaseParamFilterReader
      implements ChainableReader

  Filter which includes only those lines that contain the user-specified regular expression matching strings. Example:

      <linecontainsregexp>
         <regexp pattern="foo*">
       </linecontainsregexp>

  Or:

      <filterreader classname="org.apache.tools.ant.filters.LineContainsRegExp">
          <param type="regexp" value="foo*"/>
       </filterreader>

  This will fetch all those lines that contain the pattern `foo`

- - ### Field Summary

    - ### Fields inherited from class java.io.FilterReader

      `in`

    - ### Fields inherited from class java.io.Reader

      `lock`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `LineContainsRegExp()` | Constructor for "dummy" instances.
    `LineContainsRegExp​(java.io.Reader in)` | Creates a new filtered reader.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addConfiguredRegexp​(RegularExpression regExp)` | Adds a `regexp` element.
    `java.io.Reader` | `chain​(java.io.Reader rdr)` | Creates a new LineContainsRegExp using the passed in Reader for instantiation.
    `boolean` | `isNegated()` | Find out whether we have been negated.
    `int` | `read()` | Returns the next character in the filtered stream, only including lines from the original stream which match all of the specified regular expressions.
    `void` | `setCaseSensitive​(boolean b)` | Whether to match casesensitively.
    `void` | `setNegate​(boolean b)` | Set the negation mode.
    `void` | `setRegexp​(java.lang.String pattern)` | Set the regular expression as an attribute.

    - ### Methods inherited from class org.apache.tools.ant.filters.BaseParamFilterReader

      `getParameters, setParameters`

    - ### Methods inherited from class org.apache.tools.ant.filters.BaseFilterReader

      `getInitialized, getProject, read, readFully, readLine, setInitialized, setProject, skip`

    - ### Methods inherited from class java.io.FilterReader

      `close, mark, markSupported, ready, reset`

    - ### Methods inherited from class java.io.Reader

      `nullReader, read, read, transferTo`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### LineContainsRegExp

          public LineContainsRegExp()

      Constructor for "dummy" instances.
      See Also:
        `BaseFilterReader()`

    - #### LineContainsRegExp

          public LineContainsRegExp​(java.io.Reader in)

      Creates a new filtered reader.
      Parameters:
        `in` - A Reader object providing the underlying stream. Must not be `null`.

  - ### Method Detail

    - #### read

          public int read()
                   throws java.io.IOException

      Returns the next character in the filtered stream, only including lines from the original stream which match all of the specified regular expressions.
      Overrides:
        `read` in class `java.io.FilterReader`
      Returns:
        the next character in the resulting stream, or -1 if the end of the resulting stream has been reached
      Throws:
        `java.io.IOException` - if the underlying stream throws an IOException during reading

    - #### addConfiguredRegexp

          public void addConfiguredRegexp​(RegularExpression regExp)

      Adds a `regexp` element.
      Parameters:
        `regExp` - The `regexp` element to add. Must not be `null`.

    - #### chain

          public java.io.Reader chain​(java.io.Reader rdr)

      Creates a new LineContainsRegExp using the passed in Reader for instantiation.
      Specified by:
        `chain` in interface `ChainableReader`
      Parameters:
        `rdr` - A Reader object providing the underlying stream. Must not be `null`.
      Returns:
        a new filter based on this configuration, but filtering the specified reader

    - #### setNegate

          public void setNegate​(boolean b)

      Set the negation mode. Default false (no negation).
      Parameters:
        `b` - the boolean negation mode to set.

    - #### setCaseSensitive

          public void setCaseSensitive​(boolean b)

      Whether to match casesensitively.
      Parameters:
        `b` - boolean
      Since:
        Ant 1.8.2

    - #### isNegated

          public boolean isNegated()

      Find out whether we have been negated.
      Returns:
        boolean negation flag.

    - #### setRegexp

          public void setRegexp​(java.lang.String pattern)

      Set the regular expression as an attribute.
      Parameters:
        `pattern` - String
      Since:
        Ant 1.10.2